
var monitor = {}
monitor.processes = {}
monitor.processes.fetch = function(){
	var httpclient = HttpClient.instance()
	httpclient.get('/get/processes',monitor.processes.init);
	
}

monitor.processes.init = function(x){
	var r = JSON.parse(x.responseText)
	var keys = jx.utils.keys(r)	
	jx.dom.set.value('menu','')
	jx.utils.patterns.visitor(keys,function(label){
		var div = jx.dom.get.instance('DIV')
		var frame= jx.dom.get.instance('DIV')
		var i	= jx.dom.get.instance('I')
		i.className = 'fa fa-chevron-right left'
		
		div.innerHTML = label
		
		frame.data = r[label]
		frame.label= label
		frame.appendChild(i)
		frame.appendChild(div)
		frame.className = 'menu-item'
		frame.onclick = function(){ monitor.processes.render(this.label,this.data)}
		jx.dom.append('menu',frame)
	})
}
monitor.processes.render = function(label,data) {
	var status = {"idle":'<i class="fa fa-ellipsis-h" title="IDLE"></i>',"running":'<i class="fa fa-check" title="RUNNING"></i>',"crash":'<i class="fa fa-times" title="CRASHED"></i>'}
	data = jx.utils.patterns.visitor(data,function(row){
		var m = row.memory_usage >0
		var c = row.cpu_usage > 0
		var r = row.memory_available > 0
		console.log([row.label,m,c,r])
		console.log(row)
		if ( r && c && m) {
			row.status = status['running']
		}else if (r && (!m || !c) ){
			row.status = status['idle']
		}else if (!r){
			row.status = status['crash']
		}
		
		return row
	})
	jx.dom.set.value('latest_processes','') ;
	jx.dom.set.value('latest_processes_label',label)
	var options = {}
	
	options.data = data
	options.rowClass = function(item,index){return 'small'}
	options.autoload  = true
	options.fields = [{name:'label',type:'text',title:"Process",headercss:"small bold"},{name:"cpu_usage",type:"number",title:"CPU", headercss:"small bold"},{name:"memory_usage",type:"text",title:"Mem. Used",type:"number",headercss:"small bold"},{name:"memory_available",type:"number",title:"Mem. Avail",headercss:"small bold"},
	{name:"status",type:"text",title:"Status",headercss:"small bold",align:"center"}
	]
	var grid = $('#latest_processes').jsGrid(options) ;


}